<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on April 4, 2008 at 2:36:51 pm</time-stamp>
<!-- Package Changes for PV-Support(Green.11,bbuxton)* -->


<methods>
<class-id>PROVISO.PvRaThresholdRecord</class-id> <category>private-thresholds updating</category>

<body package="PV-Support" selector="applyBurstThreshold:currentStatistic:lastStatistic:period:">applyBurstThreshold: threshold currentStatistic: currentStatistic lastStatistic: lastStatistic period: period 
	| exceedBlock level updateBlock |
	(threshold hasBurstWarningDefined 
		and: [threshold shouldUseBurstWarningTime]) 
			ifTrue: 
				[exceedBlock := threshold warningLevelExceedBlock.
				level := threshold burstWarningLevel.
				updateBlock := [:d | self burstWarningTime: self burstWarningTime + d].
				self 
					updateDurationUsing: updateBlock
					threshold: threshold
					exceedBlock: exceedBlock
					level: level
					currentStatistic: currentStatistic
					lastStatistic: lastStatistic].
	threshold hasBurstWarningDefined 
		ifTrue: 
			[self 
				updateBurstWarningViolationThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic].
	(threshold hasBurstCriticalDefined 
		and: [threshold shouldUseBurstCriticalTime]) 
			ifTrue: 
				[exceedBlock := threshold criticalLevelExceedBlock.
				level := threshold burstCriticalLevel.
				updateBlock := [:d | self burstCriticalTime: self burstCriticalTime + d].
				self 
					updateDurationUsing: updateBlock
					threshold: threshold
					exceedBlock: exceedBlock
					level: level
					currentStatistic: currentStatistic
					lastStatistic: lastStatistic].
	threshold hasBurstCriticalDefined 
		ifTrue: 
			[self 
				updateBurstCriticalViolationThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic.
			 self 
				updateBurstCriticalResetThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic].
	threshold hasBurstWarningDefined 
		ifTrue: 
			[self 
				updateBurstWarningResetThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic].
	"Update the max percent over..."
	(self hasBurstCriticalViolation or: [self hasBurstWarningViolation]) 
		ifTrue: 
			[self updateBurstMaxPercentOverFor: threshold using: currentStatistic value]</body>

<body package="PV-Support" selector="updateBurstCriticalResetThresholdsFor:from:forPeriod:lastStatistic:">updateBurstCriticalResetThresholdsFor: statistic
	from: threshold
	forPeriod: period
	lastStatistic: lastStatistic
	
	| levelExceeded |
	levelExceeded := threshold burstCriticalLevelExceededBy: statistic value.
	(self burstCriticalTriggeredFlag and: [levelExceeded not]) 
		ifTrue: 
			[(threshold shouldSendBurstTrapForPeriod: period) 
				ifTrue: 
					["TRIGGER BURST CRITICAL RESET"
					self 
						raise: #ProvisoCriticalResetBurstThr
						forThreshold: threshold
						withStatistics: statistic
						forPeriod: ''].
			self
				burstCriticalTriggeredFlag: false].

	(levelExceeded not) ifTrue: [ self burstCriticalTime: 0]</body>

<body package="PV-Support" selector="updateBurstCriticalViolationThresholdsFor:from:forPeriod:lastStatistic:">updateBurstCriticalViolationThresholdsFor: statistic from: threshold forPeriod: period lastStatistic: lastStatistic 
	| levelExceeded |
	levelExceeded := threshold burstCriticalLevelExceededBy: statistic value.
	((threshold shouldUseBurstCriticalTime 
		and: [burstCriticalTime &gt; threshold burstCriticalTime]) 
			or: [threshold shouldUseBurstCriticalTime not and: [levelExceeded]]) 
			ifTrue: 
				["rmck: 
				 if this is the first time going from a Burst Warning to a Burst Critical Violation, then 
				we need to reset the maxBurstPercentOver to ensure when the comparison is made later on, 
				that maxBurstPercentOver will be computed against the Critical level"

				(self burstCriticalCount = 0 and: [self burstWarningCount &gt; 0]) 
					ifTrue: [self burstMaxPercentOver: 0].
				(self burstCriticalTriggeredFlag not or: 
						[threshold raiseOnValueChange and: [statistic value ~= lastStatistic value]]) 
					ifTrue: 
						[(threshold shouldSendBurstTrapForPeriod: period) 
							ifTrue: 
								["TRIGGER BURST CRITICAL VIOLATION"

								self 
									raise: #ProvisoCriticalViolationBurstThr
									forThreshold: threshold
									withStatistics: statistic
									forPeriod: ''].
						self burstCriticalTriggeredFlag 
							ifFalse: 
								[self incrementBurstCriticalCount.
								self burstCriticalTriggeredFlag: true]]].
</body>
</methods>

<methods>
<class-id>PROVISO.PvRaThresholdRecord</class-id> <category>As yet unclassified</category>

<body package="PV-Support" selector="updateBurstWarningResetThresholdsFor:from:forPeriod:lastStatistic:">updateBurstWarningResetThresholdsFor: statistic
	from: threshold
	forPeriod: period
	lastStatistic: lastStatistic
	
	| levelExceeded |
	levelExceeded := threshold burstWarningLevelExceededBy: statistic value.
	(self burstWarningTriggeredFlag and: [levelExceeded not]) 
		ifTrue: 
			[(threshold shouldSendBurstTrapForPeriod: period) 
				ifTrue: 
					["TRIGGER BURST WARNING RESET"self 
						raise: #ProvisoWarningResetBurstThr
						forThreshold: threshold
						withStatistics: statistic
						forPeriod: ''].
			self
				burstWarningTriggeredFlag: false].

	(levelExceeded not) ifTrue: [self burstWarningTime: 0].</body>

<body package="PV-Support" selector="updateBurstWarningViolationThresholdsFor:from:forPeriod:lastStatistic:">updateBurstWarningViolationThresholdsFor: statistic from: threshold forPeriod: period lastStatistic: lastStatistic 
	| levelExceeded |
	levelExceeded := threshold burstWarningLevelExceededBy: statistic value.
	((threshold shouldUseBurstWarningTime 
		and: [burstWarningTime &gt; threshold burstWarningTime]) 
			or: [threshold shouldUseBurstWarningTime not and: [levelExceeded]]) 
			ifTrue: 
				[(self burstWarningTriggeredFlag not or: 
						[threshold raiseOnValueChange and: [statistic value ~= lastStatistic value]]) 
					ifTrue: 
						[(threshold shouldSendBurstTrapForPeriod: period) 
							ifTrue: 
								["TRIGGER BURST WARNING VIOLATION"

								self 
									raise: #ProvisoWarningViolationBurstThr
									forThreshold: threshold
									withStatistics: statistic
									forPeriod: ''].
						self burstWarningTriggeredFlag 
							ifFalse: 
								[self incrementBurstWarningCount.
								self burstWarningTriggeredFlag: true]]].
</body>
</methods>

<remove-selector>
<class-id>PROVISO.PvRaThresholdRecord</class-id> <selector>updateBurstCriticalThresholdsFor:from:forPeriod:lastStatistic:</selector>
</remove-selector>

<remove-selector>
<class-id>PROVISO.PvRaThresholdRecord</class-id> <selector>updateBurstWarningThresholdsFor:from:forPeriod:lastStatistic:</selector>
</remove-selector>


</st-source>
